$! report space on a device.
$! @rptspc device nblks
$! free up nblks space on device.
$! Note this one just selects. A sorting pass to record size and/or date
$! and sort on those to get oldest/biggest first needs to be added
$! though this version is usable.
$inispc=0
$toteof=0
$totalq=0
$totnfil=0
$dvc=p1
$nblks=p2
$if dvc .eqs. "" then goto done
$if nblks .le. 0 then goto done
$find:==$gcy$sys:find
$! It is expected the selections will be set up per system and per
$! server by a script.
$! We can switch between devices here if we need to, but should do the best
$! we can on selection.
$if f$trnlnm("gcy$scratch") .eqs. "" then ass sys$scratch: gcy$scratch:
$if f$search("gcy$scratch:min1.dat") .nes. "" then delete gcy$scratch:min1.dat.
$if f$search("gcy$scratch:min2.dat") .nes. "" then delete gcy$scratch:min2.dat.
$if f$search("gcy$scratch:min3.dat") .nes. "" then delete gcy$scratch:min3.dat.
$if f$search("gcy$scratch:mks1.dat") .nes. "" then delete gcy$scratch:mks1.dat.
$if f$search("gcy$scratch:mks2.dat") .nes. "" then delete gcy$scratch:mks2.dat.
$if f$search("gcy$scratch:mks3.dat") .nes. "" then delete gcy$scratch:mks3.dat.
$! Do not alter the following line
$! Set fdefault minimum size to move and minimum age to move here.
$swpop="SWAP"
$swploc=f$trnlnm("delsav")
$dayago=7
$oldday="yesterday"
$minal=100
$medal=1000
$! Reset "dayago" or "minal" below
$!+++$$$===
$!
$today=f$time()
$day=f$integer(f$cvt(today,,"day"))
$mon=f$integer(f$cvt(today,,"month"))
$yr=f$integer(f$cvt(today,,"year"))
$if minal .lt. 10 then minal = 10
$if medal+1 .lt. minal then medal = 10 * minal
$day = day - dayago
$daylp:
$if (day .lt. 1)
$ then
$ ! compute date some number of days ago. Go back a month at a time
$ ! if this is more than just a few days.
$ dpm=31
$ yrd=0
$ if mon .eq. 1 then yrd = -1
$ if mon .eq. 3 then dpm = 28
$ if mon .eq. 5 then dpm = 30
$ if mon .eq. 7 then dpm = 30
$ if mon .eq. 12 then dpm = 30
$ day = day + dpm
$ mon = mon -1
$ if mon .lt. 1 
$ then
$ mon=12
$ yr = yr -1
$ endif
$! Date could be a couple months, so keep trying if one is not enough.
$! Note we're sloppy about leap years here.
$ dayago = dayago - dpm
$ if dayago .gt. 0 then goto daylp
$ endif
$ mstr="Jan"
$ if mon .eq. 2 then mstr="Feb"
$ if mon .eq. 3 then mstr="Mar"
$ if mon .eq. 4 then mstr="Apr"
$ if mon .eq. 5 then mstr="May"
$ if mon .eq. 6 then mstr="Jun"
$ if mon .eq. 7 then mstr="Jul"
$ if mon .eq. 8 then mstr="Aug"
$ if mon .eq. 9 then mstr="Sep"
$ if mon .eq. 10 then mstr="Oct"
$ if mon .eq. 11 then mstr="Nov"
$ if mon .eq. 12 then mstr="Dec"
$ oldday=" "
$oldday=f$string(day)+"-"+mstr+"-"+f$string(yr)
$find/char=(nocontig,nodirec,backup)/alloc=('minal','medal')/org=noindexed-
/out=gcy$scratch:mks1.dat/crea=(17-nov-1858,'oldday')/match=AND-
/revision=(17-nov-1858,'oldday')/expir=(17-nov-1858,'oldday') 'dvc'
$find/char=(nocontig,nodirec,backup)/alloc=('medal',250000)/org=noindexed-
/out=gcy$scratch:mks2.dat/crea=(17-nov-1858,'oldday')/match=AND-
/revision=(17-nov-1858,'oldday')/expir=(17-nov-1858,'oldday') 'dvc'
$find/char=(nocontig,nodirec,backup)/alloc=(10,'minal')/org=noindexed-
/out=gcy$scratch:mks3.dat/crea=(17-nov-1858,'oldday')/match=AND-
/revision=(17-nov-1858,'oldday')/expir=(17-nov-1858,'oldday') 'dvc'
$! This gets a list of files. Now edit it to a list we can USE by
$! eliminating any files of with SYS in the path or with ? in the
$! path.
$if f$file_attributes("gcy$scratch:mks1.dat","eof") .lt. 1 then exit 1
$findfct=0
$open/read ifil gcy$scratch:mks1.dat
$if f$search("gcy$scratch:min.dat") .nes. "" then delete gcy$scratch:min.dat.
$open/write ofil gcy$scratch:min1.dat
$vlin=" "
$editloop:
$read/end=editend/err=editend ifil vlin
$if f$locate("?",vlin) .lt. f$length(vlin) then goto editloop
$if f$locate(":",vlin) .ge. f$length(vlin) then goto editloop
$if f$locate("SYS",vlin) .lt. f$length(vlin) then goto editloop
$if f$locate("VMS$CO",vlin) .lt. f$length(vlin) then goto editloop
$! Don't try to swap virtual disks either
$if f$locate("DSK",vlin) .lt. f$length(vlin) then goto editloop
$! check for installed file
$if f$file_attributes(vlin,"KNOWN") .eqs. "TRUE" then goto editloop
$if f$file_attributes(vlin,"STORED_SEMANTICS") .nes. "" then goto editloop
$if f$file_attributes(vlin,"NOBACKUP") .eqs. "TRUE" THEN GOTO EDITLOOP
$! directories are contiguous so this omits them.
$if f$file_attributes(vlin,"CTG") .eqs. "TRUE" THEN GOTO EDITLOOP
$if f$file_attributes(vlin,"ORG") .EQS. "IDX" THEN GOTO EDITLOOP
$set noon
$! following tests will fail before vms v6, but are useful after.
$! Thus we tell DCL to ignore errors on these tests.
$if f$file(vlin,"MOVE") .eqs. "FALSE" then goto editloop
$if f$file(vlin,"SHELVABLE") .EQS. "FALSE" then goto editloop
$set on
$! Following line is a marker...don't mess with it.
$! Add checks on filenames below
$!+++@@@===
$!
$write ofil vlin
$goto editloop
$editend:
$close ifil
$close ofil
$findfct = findfct + 1
$! Go thru the loop again if we haven't done yet.
$ if findfct .eq. 1
$ then
$open/read ifil gcy$scratch:mks2.dat
$if f$search("gcy$scratch:min.dat") .nes. "" then delete gcy$scratch:min.dat.
$open/write ofil gcy$scratch:min2.dat
$ goto editloop
$ endif
$ if findfct .eq. 2
$ then
$open/read ifil gcy$scratch:mks3.dat
$if f$search("gcy$scratch:min.dat") .nes. "" then delete gcy$scratch:min.dat.
$open/write ofil gcy$scratch:min3.dat
$ goto editloop
$ endif
$! Now mark files for move till we have enough space.
$inispc=f$getdvi(dvc,"FREEBLOCKS")
$needspc=inispc + nblks
$open ofil gcy$scratch:min1.dat
$! Normal operation in the next loop would be to outswap files. However
$! allow the tailoring procedure to specify "LINK" or "RLNK" instead of
$! "SWAP" for swpop variable. If those operations are done, we will
$! back the file up somewhere, truncate it "here", and make a RO-softlink
$! or a normal softlink to the copy we just made. This will tie in nicely
$! with packages like Virtual Branches or Squash (which can supply alternate
$! locations for files).
$ gtalq=0
$ gteof=0
$ gtnfil=0
$ totalq = 0
$ toteof = 0
$ totnfil = 0
$spclop:
$read/end=endspc/err=endspc ofil vlin
$ thisal = f$file(f$edit(vlin,"upcase,collapse"),"ALQ")
$ thiseo = f$file(f$edit(vlin,"upcase,collapse"),"EOF")
$ totnfil = totnfil + 1
$ totalq = totalq + thisal
$ toteof = toteof + thiseo 
$ goto spclop
$endspc:
$close ofil
$ gtalq = gtalq + totalq
$ gteof = gteof + toteof
$ gtnfil = gtnfil + totnfil
$ write sys$output "For device ",dvc, "Current free blocks:",f$string(inispc)
$ write sys$output "Included File Grand Total Sizes where selecting"
$ write sys$output "files which might be outswappable/shelvable"
$ write sys$output " "
$ write sys$output "MEDIUM sized files:"
$ write sys$output "Number of files selectable:		",f$string(totnfil)
$ write sys$output "Number of blocks to EOF total:	",f$string(toteof)
$ write sys$output "Number of blocks allocated total:	",f$string(totalq)
$open ofil gcy$scratch:min2.dat
$! Normal operation in the next loop would be to outswap files. However
$! allow the tailoring procedure to specify "LINK" or "RLNK" instead of
$! "SWAP" for swpop variable. If those operations are done, we will
$! back the file up somewhere, truncate it "here", and make a RO-softlink
$! or a normal softlink to the copy we just made. This will tie in nicely
$! with packages like Virtual Branches or Squash (which can supply alternate
$! locations for files).
$ totalq = 0
$ toteof = 0
$ totnfil = 0
$spclop2:
$read/end=endspc2/err=endspc2 ofil vlin
$ thisal = f$file(f$edit(vlin,"upcase,collapse"),"ALQ")
$ thiseo = f$file(f$edit(vlin,"upcase,collapse"),"EOF")
$ totnfil = totnfil + 1
$ totalq = totalq + thisal
$ toteof = toteof + thiseo 
$ goto spclop2
$endspc2:
$close ofil
$ gtalq = gtalq + totalq
$ gteof = gteof + toteof
$ gtnfil = gtnfil + totnfil
$ write sys$output "LARGE sized files:"
$ write sys$output "Number of files selectable:		",f$string(totnfil)
$ write sys$output "Number of blocks to EOF total:	",f$string(toteof)
$ write sys$output "Number of blocks allocated total:	",f$string(totalq)
$open ofil gcy$scratch:min3.dat
$! Normal operation in the next loop would be to outswap files. However
$! allow the tailoring procedure to specify "LINK" or "RLNK" instead of
$! "SWAP" for swpop variable. If those operations are done, we will
$! back the file up somewhere, truncate it "here", and make a RO-softlink
$! or a normal softlink to the copy we just made. This will tie in nicely
$! with packages like Virtual Branches or Squash (which can supply alternate
$! locations for files).
$ totalq = 0
$ toteof = 0
$ totnfil = 0
$spclop3:
$read/end=endspc3/err=endspc3 ofil vlin
$ thisal = f$file(f$edit(vlin,"upcase,collapse"),"ALQ")
$ thiseo = f$file(f$edit(vlin,"upcase,collapse"),"EOF")
$ totnfil = totnfil + 1
$ totalq = totalq + thisal
$ toteof = toteof + thiseo 
$ goto spclop3
$endspc3:
$close ofil
$ gtalq = gtalq + totalq
$ gteof = gteof + toteof
$ gtnfil = gtnfil + totnfil
$ write sys$output "SMALL sized files:"
$ write sys$output "Number of files selectable:		",f$string(totnfil)
$ write sys$output "Number of blocks to EOF total:	",f$string(toteof)
$ write sys$output "Number of blocks allocated total:	",f$string(totalq)
$ write sys$output " GRAND TOTALS"
$ write sys$output "Number of files selectable:		",f$string(gtnfil)
$ write sys$output "Number of blocks to EOF total:	",f$string(gteof)
$ write sys$output "Number of blocks allocated total:	",f$string(gtalq)
$ ask junkk "Type return to continue>"
$done:
$exit 1
